package com.hl.account;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.CountDownTimer;
import android.util.AttributeSet;
import android.widget.Button;



/**
 * 倒计时按钮
 */
@SuppressLint("AppCompatCustomView")
public class CounterDownButton extends Button {
    private CounterDown counterDown;
    private Context mContext;
    public boolean isRunning = false;
    
    public CounterDownButton(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        mContext = context;
        init();
        
    }
    
    public CounterDownButton(Context context, AttributeSet attrs) {
        super(context, attrs);
        mContext = context;
        init();
    }
    
    public CounterDownButton(Context context) {
        super(context);
        mContext = context;
        init();
    }
    
    private void init() {
        counterDown = new CounterDown(60 * 1000, 1000);
    }
    
    public void start() {
        if (counterDown != null) {
            counterDown.start();
            isRunning = true;
        }
        setEnabled(false);
    }
    
    public void cancle() {
        if (counterDown != null) {
            counterDown.cancel();
            isRunning = false;
        }
        
        setText(mContext.getResources().getString(RTools.getString(mContext, "lksea_send_again")));
        setEnabled(true);
    }
    
    private class CounterDown extends CountDownTimer {
        
        public CounterDown(long millisInFuture, long countDownInterval) {
            super(millisInFuture, countDownInterval);
            
        }
        
        @Override
        public void onFinish() {
            setText(mContext.getResources().getString(RTools.getString(mContext,
                    "lksea_send_again")));
            setEnabled(true);
            isRunning = false;
        }
        
        @Override
        public void onTick(long millisUntilFinished) {
            String format = mContext.getResources().getString(RTools.getString(mContext,
                    "lksea_second_after_send_again"));
            setText(String.format(format, (millisUntilFinished / 1000)));
        }
    }
}
