package com.hl.account;

import android.content.Context;
import android.provider.Settings.Secure;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.UUID;

public class DeviceUtils {
    /**
     * 获取当前时间
     * */
    public static long getNowTime(){
        return System.currentTimeMillis() / 1000;
    }
    
    /**************************** UUID框架 ***********************************/
    private static String sID = null;
    private static final String INSTALLATION = "INSTALLATION";

    public synchronized static String id(Context context) {
        if (sID == null) {
            File installation = new File(context.getFilesDir(), INSTALLATION);
            try {
                if (!installation.exists()) {
                    writeInstallationFile(context, installation);
                }
                sID = readInstallationFile(installation);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        return sID;
    }

    private static String readInstallationFile(File installation) throws IOException {
        RandomAccessFile f = new RandomAccessFile(installation, "r");
        byte[] bytes = new byte[(int) f.length()];
        f.readFully(bytes);
        f.close();
        return new String(bytes);
    }

    private static void writeInstallationFile(Context context, File installation) throws IOException {
        FileOutputStream out = new FileOutputStream(installation);

        String id;
        final String androidId = Secure.getString(context.getContentResolver(), Secure.ANDROID_ID);
        if (androidId == null) {
            id = UUID.randomUUID().toString();
        } else {
            if (!"9774d56d682e549c".equals(androidId)) {
                id = androidId;
            } else {
                id = UUID.randomUUID().toString();
            }
        }
        out.write(id.getBytes());
        out.close();
    }
    /**************************** UUID框架 ***********************************/
}
