package com.hl.account;

import android.annotation.SuppressLint;
import android.content.Context;
import android.util.AttributeSet;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;


@SuppressLint("AppCompatCustomView")
public class LogoView extends ImageView implements OnClickListener {
    // logo五次点击显示版本号
    private int size = 5;
    private long[] clicks = new long[size];

    private Context cxt;

    public LogoView(Context context) {
        super(context);
        cxt = context;
        setOnClickListener(this);
    }

    public LogoView(Context context, AttributeSet attrs) {
        super(context, attrs);
        cxt = context;
        setOnClickListener(this);
    }

    public LogoView(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        cxt = context;
        setOnClickListener(this);
    }

    @Override
    public void onClick(View view) {

        for (int i = 0; i < size - 1; i++) {
            clicks[i] = clicks[i + 1];
        }
        clicks[size - 1] = System.currentTimeMillis();
        if ((clicks[size - 1] - clicks[0]) < 1500) {
//            Toast.makeText(cxt, LKBuild.VERSION, Toast.LENGTH_LONG).show();
            if (mClickFastListener != null){
                mClickFastListener.onClickfast();
            }
            
            for (int i = 0; i < size; i++) {
                clicks[i] = 0;
            }
        }
    }
    
    
    private  OnClickFastListener mClickFastListener;
    public void setClickFastListener(OnClickFastListener listener){
        mClickFastListener = listener;
    }
    
    public interface OnClickFastListener{
        void onClickfast();
    }
}