package com.hl.demo;

import android.app.Application;
import android.content.Context;
import android.content.res.Configuration;
import android.os.Process;
import android.text.TextUtils;

import com.hoolai.access.open.fastaccess.channel.FastSdk;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

public class GameApplication extends Application {

    @Override
    public void onCreate() {
        super.onCreate();
        //如使用了Multidex 需要指定 hoolaisdk相关代码到主dex中
        //-keep com.hoolai.**
        FastSdk.onApplicationCreate(this);
    }

    @Override
    public void onTerminate() {
        super.onTerminate();
        FastSdk.onTerminate(this);
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        FastSdk.onConfigurationChanged(this, newConfig);

    }

    @Override
    protected void attachBaseContext(Context context) {
        super.attachBaseContext(context);
        FastSdk.attachBaseContext(this, context);
    }


    /**
     * 多进程判断,sdk已经做了处理,游戏可不做处理
     * @param application
     * @return
     */
    public static boolean getProcessPerform(Application application){
        String processName = getProcessName();
        int pid = Process.myPid();
        LogUtil.i("my pid:"+pid+",processName:"+processName);
        if(!TextUtils.isEmpty(processName) && processName.equals(application.getPackageName())){
            return true;
        }
        return false;
    }

    public static String getProcessName() {
        try {
            File file = new File("/proc/" + Process.myPid() + "/" + "cmdline");
            BufferedReader mBufferedReader = new BufferedReader(new FileReader(file));
            String processName = mBufferedReader.readLine().trim();
            mBufferedReader.close();
            return processName;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}
